<?php

namespace FM\Service;

use FM\Factory\ServicosFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;

class ServicosService
{

    protected $ServicosFactory;
    protected $Environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, ServicosFactory $ServicosFactory, Environment $Environment, NewCode $newCode)
    {
        $this->ServicosFactory           = $ServicosFactory;
        $this->connection                = $entityManager->getConnection();
        $this->Environment               = $Environment;
        $this->newCode                   = $newCode;
    }

    public function getInformacoesServico()
    {
        return $this->ServicosFactory->getInformacoesServico();
    }
    /*
    public function getProdFaturamento() {
        return $this->ServicosFactory->getProdFaturamento();
    }

    public function inserirServico($parametros) {
        $this->connection->beginTransaction();

        try {
            $nrorg = $this->Environment->getNrorg();
            $cdoperador = $this->Environment->getCdOperador();

            if ($parametros['CDSERVORCA'] == null) {
                $cdservorca = $this->newCode->getCodeByTableName("FCT_SERVICOORCA", $nrorg, 1, 10, true);

                $params = array (
                    "CDSERVORCA"     => $cdservorca,
                    "NMSERVORCA"     => $parametros['NMSERVORCA'],
                    "DSSERVORCA"     => $parametros['DSSERVORCA'],
                    "CDPRODFATSERV"  => $parametros['CDPRODUTO'],
                    "CDOPERINCLUSAO" => $cdoperador,
                    "NRORG"          => $nrorg,
                    "IDATIVO"        => $parametros['IDATIVO'],
                );

                $this->ServicosFactory->inserirServico($params);

            } else {
                if ($parametros['IDATIVO'] == 'S') {
                    $params = array (
                        "CDSERVORCA"     => $parametros['CDSERVORCA'],
                        "NMSERVORCA"     => $parametros['NMSERVORCA'],
                        "DSSERVORCA"     => $parametros['DSSERVORCA'],
                        "CDOPERULTATU"   => $cdoperador,
                        "IDATIVO"        => $parametros['IDATIVO']
                    );
                    $this->ServicosFactory->atualizarServico($params);
                } else {
                    throw new \Exception("IDATIVO != S");
                }
            }
            $this->connection->commit();

        }  catch(\Exception $e) {
          $this->connection->rollback();
          throw $e;
        }
    }

    public function deletarServicos($parametros) {
        $this->connection->beginTransaction();

        try {

            foreach($parametros['NRS'] as $nr) {

                $param = array(
                    "CDSERVORCA" => $nr
                );

                $this->ServicosFactory->deletarServicos($param);
            }
            $this->connection->commit();

        }  catch(\Exception $e) {
          $this->connection->rollback();
          throw $e;
        }
    }
    */
}
